import edu.rice.cnc.translator.GraphDescription._
import edu.rice.cnc.api.Point

/**
 * @author Shams Imam (shams@rice.edu)
 * @since 1/2/12 5:23 PM
 */

object FindPrimesCncDefinition {
  def main(args: Array[String]): Unit = {
    ApplicationName("FindPrimes")
    TargetPackage("findprimes") // default package
    TargetDirectory("findprimes")

    Comment("Item Collections")
    ItemCollection[Point, Int]("primes")

    Comment("Tag Collections")
    TagCollection[Point]("oddNums")

    Comment("Step Prescriptions")
    Presription("oddNums", List("compute"))

    Comment("Step Dependences")
    StepDependence("compute", List[String](), List("primes"))

    Comment("Environment Collections")
    EnvironmentDependence(
      List("oddNums"),
      List("primes")
    )
  }
}